"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TemperatureSensor = void 0;
var baseContainers_1 = require("./baseContainers");
var container_utils_1 = require("../container_utils");
var TemperatureSensor = /** @class */ (function (_super) {
    __extends(TemperatureSensor, _super);
    function TemperatureSensor(deviceID) {
        var _this = _super.call(this, deviceID) || this;
        _this._temperature = container_utils_1.NO_VALUE.toString();
        _this._humidityPercentage = container_utils_1.NO_VALUE;
        _this._batteryPercentage = container_utils_1.NO_VALUE;
        return _this;
    }
    Object.defineProperty(TemperatureSensor.prototype, "temperature", {
        // ======================= GETTERS & SETTERS =======================
        get: function () {
            return this._temperature;
        },
        set: function (value) {
            this._temperature = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TemperatureSensor.prototype, "humidityPercentage", {
        get: function () {
            return this._humidityPercentage;
        },
        set: function (value) {
            this._humidityPercentage = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TemperatureSensor.prototype, "batteryPercentage", {
        get: function () {
            return this._batteryPercentage;
        },
        set: function (value) {
            this._batteryPercentage = value;
        },
        enumerable: false,
        configurable: true
    });
    TemperatureSensor.prototype.setSensorData = function (temperature, humidityPercentage, batteryPercentage) {
        this.temperature = temperature;
        this.humidityPercentage = humidityPercentage;
        this.batteryPercentage = batteryPercentage;
    };
    // ======================= API =======================
    TemperatureSensor.prototype.retrieveGetRequestDeviceData = function (tuyaCloudResponse) {
        return __awaiter(this, void 0, void 0, function () {
            var temperatureMatch, temperature, humidityPercentageMatch, humidityPercentage, batteryPercentageMatch, batteryPercentage;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.retrieveGetRequestGeneralData(tuyaCloudResponse)];
                    case 1:
                        _a.sent();
                        temperatureMatch = this.cloudResponseString.match(/"code":"va_temperature","value":(\d+)/);
                        temperature = temperatureMatch ? temperatureMatch[1] : container_utils_1.NO_VALUE.toString();
                        if (+temperature == container_utils_1.NO_VALUE)
                            throw new Error('Could not retrieve the temperature!');
                        temperature =
                            temperature.substring(0, temperature.length - 1) + '.' + temperature.substring(temperature.length - 1);
                        humidityPercentageMatch = this.cloudResponseString.match(/"code":"va_humidity","value":(\d+)/);
                        humidityPercentage = humidityPercentageMatch ? humidityPercentageMatch[1] : container_utils_1.NO_VALUE;
                        if (+humidityPercentage == container_utils_1.NO_VALUE)
                            throw new Error('Could not retrieve the humidity percentage!');
                        batteryPercentageMatch = this.cloudResponseString.match(/"code":"battery_percentage","value":(\d+)/);
                        batteryPercentage = batteryPercentageMatch ? batteryPercentageMatch[1] : container_utils_1.NO_VALUE;
                        if (+batteryPercentage == container_utils_1.NO_VALUE)
                            throw new Error('Could not retrieve the battery percentage!');
                        this.setSensorData(temperature, +humidityPercentage, +batteryPercentage);
                        return [2 /*return*/];
                }
            });
        });
    };
    TemperatureSensor.prototype.stringifyData = function () {
        var jsonData = {
            requestSuccess: this.tuyaGetRequestGeneralData.success,
            requestTime: this.tuyaGetRequestGeneralData.timestamp,
            deviceName: this.tuyaGetRequestGeneralData.deviceName,
            deviceStatus: this.tuyaGetRequestGeneralData.deviceStatus,
            updateTime: this.tuyaGetRequestGeneralData.updateTime,
            temperature: this.temperature,
            humidityPercentage: this.humidityPercentage,
            batteryPercentage: this.batteryPercentage,
        };
        return JSON.stringify(jsonData);
    };
    TemperatureSensor.prototype.printDataToConsole = function () {
        console.log('=================================================');
        console.log('Request success: ' + this.tuyaGetRequestGeneralData.success);
        console.log('Device name: ' + this.tuyaGetRequestGeneralData.deviceName);
        console.log('Device status: ' + this.tuyaGetRequestGeneralData.deviceStatus);
        console.log('Time: ' + this.tuyaGetRequestGeneralData.timestamp);
        console.log('Update time: ' + this.tuyaGetRequestGeneralData.updateTime);
        console.log('Temperature: ' + this.temperature);
        console.log('Humidity: ' + this.humidityPercentage);
        console.log('Battery: ' + this.batteryPercentage);
        console.log('=================================================');
    };
    return TemperatureSensor;
}(baseContainers_1.TuyaDevice));
exports.TemperatureSensor = TemperatureSensor;
